Bug Hunting Session
Bug 94006 - OpenGLContext - ref-counted and manually managed ...
Summary: OpenGLContext - ref-counted and manually managed ...
Status: RESOLVED FIXED
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: graphics stack (show other bugs)
Version:
(earliest affected)
5.0.2.1 rc
Hardware: Other All
: medium normal
Assignee: Not Assigned
URL:
Whiteboard: target:5.1.0 target:5.0.3 target:5.0.2
Keywords:
Depends on:
Blocks: VCL-OpenGL
  Show dependency treegraph
 
Reported: 2015-09-07 21:10 UTC by Michael Meeks
Modified: 2016-10-25 19:24 UTC (History)
2 users (show)

See Also:
Crash report or crash signature:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Michael Meeks 2015-09-07 21:10:35 UTC
Something of a confusion of lifecycle methods are used for the OpenGLContext - it is reference counted via Ref / DeRef - and actively re-used (to avoid context switching cost) - but it is also (in older code) allocated as a member eg.

avmedia/source/opengl/oglplayer.hxx:    OpenGLContext m_aContext;
vcl/source/window/openglwin.cxx:    OpenGLContext maContext;

etc.

Currently working to de-bong this using rtl::Reference ...
Comment 1 Michael Meeks 2015-09-07 21:35:13 UTC
Fixes here:

https://gerrit.libreoffice.org/18389 tdf#94006 - re-factor to use rtl::Reference for OpenGLContexts.
https://gerrit.libreoffice.org/18390 tdf#94006 - fix OpenGLContext mis-use in several places.
Comment 2 Commit Notification 2015-09-08 12:01:49 UTC
Michael Meeks committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=2456cf8306be22e32130e789ab939c059e5e79e5

tdf#94006 - re-factor to use rtl::Reference for OpenGLContexts.

It will be available in 5.1.0.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.
Comment 3 Commit Notification 2015-09-08 12:01:53 UTC
Michael Meeks committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=56900a441de1d4cc896ad1e36a44622ed1598fad

tdf#94006 - fix OpenGLContext mis-use in several places.

It will be available in 5.1.0.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.
Comment 4 Michael Meeks 2015-09-08 12:14:39 UTC
Squashed the two separate fixes into one for -5-0 here:
   https://gerrit.libreoffice.org/18405
Review appreciated etc.
Verified that OpenGLContext's are in fact destroyed, and tested on Windows & Linux for regressions.
Comment 5 Commit Notification 2015-09-08 15:10:15 UTC
Michael Meeks committed a patch related to this issue.
It has been pushed to "libreoffice-5-0":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=61b7d3436fb789fecf460d2b47c7210585f496a5&h=libreoffice-5-0

tdf#94006 - re-factor and fix OpenGLContext mis-use.

It will be available in 5.0.3.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.
Comment 6 Commit Notification 2015-09-08 15:48:34 UTC
Michael Meeks committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=82d25c02f8569aadf166fa92fb581fa68c12fbd1

tdf#94006 - need an explicit dispose for GLContext's SystemChildWindow.

It will be available in 5.1.0.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.
Comment 7 Commit Notification 2015-09-08 16:31:42 UTC
Michael Meeks committed a patch related to this issue.
It has been pushed to "libreoffice-5-0":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=56ece7860dc16b244cb7d409ff4ffcb2dd88f76a&h=libreoffice-5-0

tdf#94006 - need an explicit dispose for GLContext's SystemChildWindow.

It will be available in 5.0.3.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.
Comment 8 Commit Notification 2015-09-11 09:48:48 UTC
Michael Meeks committed a patch related to this issue.
It has been pushed to "libreoffice-5-0-2":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=3265f2b2ea074965e145496c219360819996d432&h=libreoffice-5-0-2

tdf#94006 - re-factor and fix OpenGLContext mis-use.

It will be available in 5.0.2.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.
Comment 9 Commit Notification 2015-09-11 09:51:13 UTC
Michael Meeks committed a patch related to this issue.
It has been pushed to "libreoffice-5-0-2":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=2c27c810027d8b01237c0f97359a3fadd6455a45&h=libreoffice-5-0-2

tdf#94006 - need an explicit dispose for GLContext's SystemChildWindow.

It will be available in 5.0.2.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.
Comment 10 Commit Notification 2015-09-16 02:04:18 UTC
Michael Meeks committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=625d83e430a4caf35675d2900c11ab6929a8304a

tdf#94006 - need an explicit dispose for slideshow's GLContext.

It will be available in 5.1.0.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.
Comment 11 Commit Notification 2015-09-16 12:31:56 UTC
Michael Meeks committed a patch related to this issue.
It has been pushed to "libreoffice-5-0":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=0ff1cd30959b4e2eba9372cfb786c6bf3947bd38&h=libreoffice-5-0

tdf#94006 - need an explicit dispose for slideshow's GLContext.

It will be available in 5.0.3.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.
Comment 12 Commit Notification 2015-09-16 16:27:06 UTC
Michael Meeks committed a patch related to this issue.
It has been pushed to "libreoffice-5-0-2":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=bde953b84baed33098ae747c49a882e14a2bf7c7&h=libreoffice-5-0-2

tdf#94006 - need an explicit dispose for slideshow's GLContext.

It will be available in 5.0.2.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.